require 'rbconfig'

class Platform

  def Platform.isWindows?
    Platform.isMSWin32? ||
    Platform.isMingw32? ||
    Platform.isCygwin?  ||
    Platform.isBCCWin32?
  end
  
  def Platform.isPosix?
    not Platform.isWindows?
  end
  
  def Platform.isCygwin?
    Config::CONFIG["arch"] =~ /cygwin/
  end
  
  def Platform.isMingw32?
    Config::CONFIG["arch"] =~ /mingw32/
  end
  
  def Platform.isMSWin32?
    Config::CONFIG["arch"] =~ /mswin32/
  end

  def Platform.isBCCWin32?
    Config::CONFIG["arch"] =~ /bccwin32/
  end
  
  def Platform.settings_file
    if Platform.isWindows?
      return ENV['HOME'] + "/Local Settings/rdcl.yaml"
    else
      return ENV['HOME'] + "/.rdcl.yaml"
    end
  end
  
end